;##################################################################
; LISTVIEW
;##################################################################
#include "TestListView.Inc"

#include "\RadASM\GoAsm\inc\debug.a"
DBGWIN_DEBUG_ON = 1 ; use this to enable Spy/StopSpy/DbgDump and TrapException
DBGWIN_SHOWONLYERRORS = 1 ; setting this to 1 will suppress PrintError if no error exists 

LVSORT struct
handle dd
direction dd
column dd
type dd
ENDS

LVHITTESTINFO STRUCT
	pt			POINT	<>
	flags		DD		?
	iItem		DD		?
	iSubItem	DD		?
ENDS

HDRIMAGE struct
	dwItem	DD
	dwDir	DD
ENDS

CBDATA struct
	pOldProc	DD
	hParent		DD
	iItem		DD
	iSubitem	DD
	fType		DD
ENDS

.CONST
	TOPMSG				equ			2048
	TEXTCOLOR			equ		0FF0000h
CONTROLTEXTCLR		equ		000000FFh
DROPHILITECLR		equ		0097FFFFh
CONTROLSELCLR		equ		0000FFFFh

.DATA
	MsgTable			DD			TOPMSG DUP (?)
	szColumn0			DB			"Column 0",0
	szColumn1			DB			"Column 1",0
	szColumn2			DB			"Column 2",0
	szColumn3			DB			"Column 3",0,0

	hInstance			DD 			?
	icc	 				DQ			3FFF00000008h
	hDlg				DD			?
	hListView			DD			?
	hHeader				DD			?
	hClipData			DD			?
	hIml				DD			?
	
	pListViewFunc		DD			?
	
	buffer				DB			256 DUP (?)
	lvsort				LVSORT		<>

	hBrush				DD			?
	hLVBrush			DD			?
	
	ArialFont			LOGFONT		<-13,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"Arial">
	hArialFont			DD			?
	
	CBFont				LOGFONT		<-11,0,0,0,FW_NORMAL,FALSE,FALSE,0,0,0,0,0,0,"Arial">
	hCBFont				DD			?

	hdimage				HDRIMAGE	<-1,0>

	cbstring			DB			256 DUP (?)
	cbparams			CBDATA		<>

	CB_SetContent(hControl,pList) =	push edi \
									push esi \
									mov esi,pList \
									push esi \
									C1: \
										add esi,1 \
										mov al,[esi] \
										cmp al,0 \
										jne <C1 \
										add esi,1 \
										push 0 \
										push 143h \
										push hControl \
										call SendMessageA \
										mov cl,[esi] \
										cmp cl,0 \
										je >C2 \
										push esi \
										jmp <C1 \
									C2: \
									pop esi \
									pop edi


	ExePath	DB	MAX_PATH DUP (?)
	ExeName	DB	MAX_PATH DUP (?)


.CODE
BuildMessageTable:
	uses edi,ecx,eax
	; Set the default proc for all messages to WM_USER+1023
	mov edi,OFFSET MsgTable
	mov ecx,TOPMSG-1
	mov eax,OFFSET DEFPROC
	rep stosd
	; Set the offsets of the messages to process
	mov [MsgTable+(WM_INITDIALOG *4)],OFFSET WMINITDIALOG
	mov [MsgTable+(WM_COMMAND *4)],OFFSET WMCOMMAND
	mov [MsgTable+(WM_CLOSE *4)],OFFSET WMCLOSE
	mov [MsgTable+(WM_NOTIFY *4)],OFFSET WMNOTIFY
	mov [MsgTable+(WM_CONTEXTMENU *4)],OFFSET WMCONTEXTMENU
	mov [MsgTable+(WM_DESTROYCLIPBOARD *4)],OFFSET WMDESTROYCLIPBOARD
	mov [MsgTable+(WM_CTLCOLORDLG *4)],OFFSET WMCTLCOLORDLG
	mov [MsgTable+(WM_CTLCOLORSTATIC *4)],OFFSET WMCTLCOLORSTATIC
	mov [MsgTable+(WM_NCACTIVATE *4)],OFFSET WMNCACTIVATE
	mov [MsgTable+(WM_MOUSEACTIVATE *4)],OFFSET WMMOUSEACTIVATE
	;mov [MsgTable+(WM_NCLBUTTONUP *4)],OFFSET WMNCLBUTTONUP
	ret
	endu

Start:
	call BuildMessageTable
	invoke GetModuleHandle, 0
	mov [hInstance],eax
	invoke CreateSolidBrush,0FF8080h
	mov [hBrush],eax
	invoke CreateFontIndirect,OFFSET ArialFont
	mov [hArialFont],eax
	invoke CreateFontIndirect,OFFSET CBFont
	mov [hCBFont],eax
	invoke CreateSolidBrush,0000FFFFh ;brush for the listview
	mov [hLVBrush],eax
	invoke InitCommonControlsEx,OFFSET icc
	invoke DialogBoxParam,[hInstance],1000,0,ADDR DlgProc,0
	invoke DeleteObject,[hBrush]
	invoke DeleteObject,[hLVBrush]
	invoke DeleteObject,[hArialFont]
	invoke DeleteObject,[hCBFont]
	invoke ExitProcess,0

DlgProc FRAME hwnd,uMsg,wParam,lParam
	uses edi,ebx,esi
	LOCAL hdi		:HDITEM
	LOCAL lvhi		:LVHITTESTINFO
	LOCAL ps		:PAINTSTRUCT
	LOCAL rect		:RECT
	LOCAL lbr		:LOGBRUSH
	LOCAL lvi		:LV_ITEM

	mov eax,[uMsg]
	cmp eax,TOPMSG-1
	ja >DEFPROC
	jmp [MsgTable+eax*4]

	WMCTLCOLORDLG:
		mov eax,[hBrush]
		ret

	WMCTLCOLORSTATIC:
		invoke GetObject,[hBrush],SIZEOF LOGBRUSH,OFFSET lbr
		mov ebx,[wParam] ; hDC
		invoke SetBkColor,ebx,[lbr.lbColor]
		invoke SetTextColor,ebx,0000FFFFh
		mov eax,[hBrush]
		ret

	WMNOTIFY:
		mov edi,[lParam]
		cmp D[edi+NMHDR.code],HDN_ITEMCLICK
		jnz >>.HDN_ITEMCHANGED
			mov D[hdi._mask],HDI_IMAGE + HDI_FORMAT
			invoke SendMessage,[hHeader],HDM_GETITEM,[edi+NMHEADER.iItem],ADDR hdi
			test D[hdi.fmt],HDF_IMAGE
			jz >>.WMN_DONE
				mov eax,[hdimage.dwItem]
				or eax,eax
				js >H1
					cmp eax,[edi+NMHEADER.iItem]
					je >H2
						mov ecx,0
						invoke SendMessage,[hHeader],HDM_SETITEM,[hdimage.dwItem],ADDR hdi
						mov D[hdimage.dwDir],1
						mov ecx,1
						jmp >H1
					H2:
						mov ecx,[hdimage.dwDir]
						test ecx,1
						je >
							mov ecx,2
							jmp >H1
						:
							mov ecx,1
				H1:
				mov eax,[edi+NMHEADER.iItem]
				mov [hdimage.dwItem],eax
				mov [hdi.iImage],ecx
				mov [hdimage.dwDir],ecx
				; D[hdi.iItem] = the header item that was clicked
				; D[hdi.iImage] = the current image
				; set to 0 = no arrow, 1 = down arrow, 2 = up arrow
				invoke SendMessage,[hHeader],HDM_SETITEM,[edi+NMHEADER.iItem],ADDR hdi

				; Sort the column by text based on the direction arrow
				mov eax,[hListView]
				mov [lvsort.handle],eax ; Handle of the listview to sort
				mov eax,[hdimage.dwDir]
				shr eax,1
				mov D[lvsort.direction],eax ; FALSE = ascending , TRUE = descending
				mov eax,[edi+NMHEADER.iItem]
				mov D[lvsort.column],eax ; Column to sort
				mov D[lvsort.type],1 ; 0 = param, 1 = string, 2 = image index
				invoke SendMessage, [hListView], LVM_SORTITEMSEX, OFFSET lvsort, OFFSET LVSortProc
				jmp >>.WMN_DONE

		.HDN_ITEMCHANGED
		cmp D[edi+NMHDR.code],HDN_ITEMCHANGED
		jnz >.NM_CLICK
			; Redraw the listview when header resized
			invoke InvalidateRect,[hListView],NULL,NULL
			invoke UpdateWindow,[hListView]
			jmp >>.WMN_DONE

		.NM_CLICK
		cmp D[edi+NMHDR.code],NM_CLICK
		jnz >>.NM_DBLCLK
			invoke SendDlgItemMessage,[hListView],999,WM_CLOSE,0,0
			invoke GetMessagePos
			movzx ecx,ax
			mov [lvhi.pt.x],ecx
			shr eax,16
			movzx ecx,ax
			mov [lvhi.pt.y],ecx
			invoke ScreenToClient,[hListView],ADDR lvhi.pt
			invoke SendMessage,[hListView],LVM_SUBITEMHITTEST,0,OFFSET lvhi
			; returns the column and item that was clicked in lvhi
			mov eax,[lvhi.iItem]
			mov [lvi.iItem],eax
			mov D[lvi.iSubItem],0
			mov D[lvi.cchTextMax],255
			mov [lvi.pszText],OFFSET buffer
			invoke SendMessage,[hListView],LVM_GETITEMTEXT,[lvhi.iItem],OFFSET lvi
			invoke SetDlgItemText,[hwnd],1002,OFFSET buffer
			jmp >>.WMN_DONE

		.NM_DBLCLK
		cmp D[edi+NMHDR.code],NM_DBLCLK
		jnz >>.NM_CUSTOMDRAW
			invoke SendDlgItemMessage,[hListView],999,WM_CLOSE,0,0
			invoke GetMessagePos
			movzx ecx,ax
			mov [lvhi.pt.x],ecx
			shr eax,16
			movzx ecx,ax
			mov [lvhi.pt.y],ecx
			invoke ScreenToClient,[hListView],OFFSET lvhi.pt
			invoke SendMessage,[hListView],LVM_SUBITEMHITTEST,0,OFFSET lvhi
			; returns the column and item that was clicked in lvhi
			cmp D[lvhi.iSubItem],2
			jne >>D1
				mov eax,[lvhi.iSubItem]
				mov [rect.top],eax
				mov D[rect.left],LVIR_LABEL
				invoke SendMessage,[hListView],LVM_GETSUBITEMRECT,[lvhi.iItem],OFFSET rect
				mov eax,[rect.bottom]
				sub eax,[rect.top]
				push eax
				mov ecx,[rect.right]
				sub ecx,[rect.left]
				sub D[rect.top],1
				invoke CreateWindowEx,NULL,"COMBOBOX",NULL,CBS_OWNERDRAWFIXED+WS_CHILD \
					+WS_VISIBLE+CBS_DROPDOWNLIST+CBS_HASSTRINGS,[rect.left],\
					[rect.top],ecx,100,[hListView],999,[hInstance],NULL
				mov ebx,eax
				invoke SetWindowLong,ebx,GWL_WNDPROC,OFFSET LVEditBox
				mov [cbparams.pOldProc],eax
				mov eax,[hListView]
				mov [cbparams.hParent],eax
				mov eax,[lvhi.iItem]
				mov [cbparams.iItem],eax
				mov eax,[lvhi.iSubItem]
				mov [cbparams.iSubitem],eax
				mov D[cbparams.fType],0
				invoke SetWindowLong,ebx,GWL_USERDATA,OFFSET cbparams
				invoke SendMessage,ebx,WM_SETFONT,[hCBFont],TRUE
				CB_SetContent(ebx,OFFSET szColumn0)
				pop eax
				; less the borders
				sub eax,4
				invoke SendMessage,ebx,CB_SETITEMHEIGHT,-1,eax
				invoke SetFocus,ebx
			D1:
			cmp D[lvhi.iSubItem],3
			jne >>D2
				mov eax,[lvhi.iSubItem]
				mov [rect.top],eax
				mov D[rect.left],LVIR_LABEL
				invoke SendMessage,[hListView],LVM_GETSUBITEMRECT,[lvhi.iItem],OFFSET rect
				mov eax,[rect.bottom]
				sub eax,[rect.top]
				mov ecx,[rect.right]
				sub ecx,[rect.left]
				sub D[rect.top],1
				invoke CreateWindowEx,NULL,"SysDateTimePick32",NULL,WS_CHILD+WS_VISIBLE,[rect.left],\
					[rect.top],ecx,eax,[hListView],999,[hInstance],NULL
				mov ebx,eax
				invoke SetWindowLong,ebx,GWL_WNDPROC,OFFSET LVEditBox
				mov [cbparams.pOldProc],eax
				mov eax,[hListView]
				mov [cbparams.hParent],eax
				mov eax,[lvhi.iItem]
				mov [cbparams.iItem],eax
				mov eax,[lvhi.iSubItem]
				mov [cbparams.iSubitem],eax
				mov D[cbparams.fType],1 ; Date time picker
				invoke SetWindowLong,ebx,GWL_USERDATA,OFFSET cbparams
			D2:
			mov eax,[lvhi.iItem]
			mov [lvi.iItem],eax
			mov D[lvi.iSubItem],0
			mov D[lvi.cchTextMax],255
			mov [lvi.pszText],OFFSET buffer
			invoke SendMessage,[hListView],LVM_GETITEMTEXT,[lvhi.iItem],OFFSET lvi
			invoke SetDlgItemText,[hwnd],1002,OFFSET buffer
			jmp >>.WMN_DONE

		.NM_CUSTOMDRAW
			cmp D[edi+NMHDR.code],NM_CUSTOMDRAW
			jne >>.WMN_DONE
			mov eax,[wParam]
			cmp eax,1001
			jne >>.WMN_DONE
				mov edi,[lParam]
				mov eax,[edi+NMLVCUSTOMDRAW.nmcd.dwDrawStage]
				cmp eax,CDDS_PREPAINT
				jne >
					; Request an item draw notification
					invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_NOTIFYITEMDRAW
					xor eax,eax
					inc eax
					ret
				:
				cmp eax,CDDS_ITEMPREPAINT
				jne >>P1
					; The item is about to be painted
					; intercept the paint process to do our own thing
					mov eax,[edi+NMLVCUSTOMDRAW.nmcd.uItemState]
					test eax,CDIS_SELECTED
					je >>
						; A selected item is being drawn
						; Get the item number
						mov esi,[edi+NMLVCUSTOMDRAW.nmcd.dwItemSpec]
						; Get the bounding rect of the icon
						mov D[rect.left],LVIR_ICON
						invoke SendMessage,[hListView],LVM_GETITEMRECT,esi,OFFSET rect
						push [rect.right]
						; Get the bounding rect of the item
						mov D[rect.left],LVIR_BOUNDS
						invoke SendMessage,[hListView],LVM_GETITEMRECT,esi,OFFSET rect
						pop ecx ; pop the right side of the icon
						inc ecx ; one pixel space
						mov [rect.left],ecx

						; Get the device context
						mov ebx,[edi+NMLVCUSTOMDRAW.nmcd.hdc]

						; Draw the background color
						invoke FillRect,ebx,OFFSET rect,[hLVBrush]

						; Set the text background color
						invoke GetObject,[hLVBrush],SIZEOF LOGBRUSH,OFFSET lbr
						invoke SetBkColor,ebx,[lbr.lbColor]
						push eax ; push the old background color
						; Set the text color
						invoke SetTextColor,ebx,000000FFh
						push eax ; push the old text color

						; Get the item count from the header control
						invoke SendMessage,[hListView],LVM_GETHEADER,0,0
						invoke SendMessage,eax,HDM_GETITEMCOUNT,0,0
						mov ecx,eax

						; Loop through all the labels and draw their text
						mov [lvi.iItem],esi
						mov [lvi.pszText],OFFSET buffer
						mov D[lvi.cchTextMax],255
						; EDI is no longer needed so we'll use it for a counter
						xor edi,edi
						jmp >W1
						W2:
							push ecx ; save the item count
							; Get the bounding rect of the label
							; the API uses the rect struct to pass parameters
							mov D[rect.left],LVIR_LABEL
							mov D[rect.top],edi
							invoke SendMessage,[hListView],LVM_GETSUBITEMRECT,esi,OFFSET rect
							or edi,edi
							jz >W3
								add D[rect.left],4 ; extra indent for sub items
							W3:
							add D[rect.left],2 ; indent isn't right with LVM_GETITEM
							mov D[lvi.iSubItem],edi
							invoke SendMessage,[hListView],LVM_GETITEMTEXT,esi,OFFSET lvi
							; Draw the text to the items
							invoke DrawText,ebx,OFFSET buffer,-1,OFFSET rect,DT_LEFT + DT_VCENTER + DT_SINGLELINE
							pop ecx ; restore the item count
							inc edi
						W1:
						cmp edi,ecx ; have we reached the last item ?
						jl <W2

						pop eax ; pop the old text color
						invoke SetTextColor,ebx,eax
						pop eax ; pop the old background color
						invoke SetBkColor,ebx,eax

						; Draw the icon and we're all done !
						mov D[lvi.imask],LVIF_IMAGE
						mov [lvi.iItem],esi
						mov D[lvi.iSubItem],0
						invoke SendMessage,[hListView],LVM_GETITEM,0,OFFSET lvi
						invoke SendMessage,[hListView],LVM_GETIMAGELIST,LVSIL_SMALL,0
						mov edi,eax
						mov D[rect.left],LVIR_ICON
						invoke SendMessage,[hListView],LVM_GETITEMRECT,esi,OFFSET rect
						invoke ImageList_Draw,edi,[lvi.iImage],ebx,[rect.left],[rect.top],ILD_BLEND50

						; The drawing is all done so skip the default draw
						invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_SKIPDEFAULT
						xor eax,eax
						inc eax
						ret
					:
						; Set the text and background colors
						mov D[edi+NMLVCUSTOMDRAW.clrTextBk],0FFFFFFh
						mov D[edi+NMLVCUSTOMDRAW.clrText],0FF0000h
						; The item is not selected so use the default draw
						invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_DODEFAULT
						xor eax,eax
						inc eax
						ret
				P1:
				invoke SetWindowLong,[hwnd],DWL_MSGRESULT,CDRF_DODEFAULT
				xor eax,eax
				inc eax
				ret

		.WMN_DONE
		xor eax,eax
		ret

	WMCOMMAND:

		jmp >>.EXIT

	WMCONTEXTMENU:
		invoke ShowLVMenu,[hwnd]
		xor eax,eax
		inc eax
		ret

	WMDESTROYCLIPBOARD:
		invoke GlobalFree,[hClipData]
		xor eax,eax
		inc eax
		ret

	WMINITDIALOG:
		mov eax,[hwnd]
		mov [hDlg],eax
		invoke SendDlgItemMessage,[hDlg],1002,WM_SETFONT,[hArialFont],TRUE
		invoke GetDlgItem,[hDlg],1001
		mov [hListView],eax
		invoke SendMessage,[hListView],LVM_GETHEADER,0,0
		mov [hHeader],eax
		call SetUpListView
		; LVAddItem,iIcon,ptext0,ptext1,ptext2,ptext3
		invoke LVAddItem,0,"Item 1","SubItem 6",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 2","SubItem 1",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,0,"Item 3","SubItem 7",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 4","SubItem 0",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,0,"Item 5","SubItem 4",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 6","SubItem 3",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,0,"Item 7","SubItem 5",OFFSET szColumn2,OFFSET szColumn3
		invoke LVAddItem,1,"Item 8","SubItem 2",OFFSET szColumn2,OFFSET szColumn3

		invoke SetWindowPos,[hwnd],HWND_BOTTOM,0,0,0,0,SWP_NOMOVE + SWP_NOSIZE
		xor eax,eax
		inc eax
		ret

	WMNCACTIVATE:
		cmp D[wParam],TRUE
		jne >
		invoke SetWindowPos,[hwnd],HWND_BOTTOM,0,0,0,0,SWP_NOMOVE + SWP_NOSIZE
		invoke SetWindowLong,[hwnd],DWL_MSGRESULT,FALSE
		jmp >>.EXIT
		:
		invoke SetWindowLong,[hwnd],DWL_MSGRESULT,TRUE
		jmp >>.EXIT

	WMMOUSEACTIVATE:
		invoke SetWindowLong,[hwnd],DWL_MSGRESULT,MA_NOACTIVATE
		mov eax,MA_NOACTIVATE
		ret
		jmp >DEFPROC
		;invoke SetWindowPos,[hwnd],HWND_BOTTOM,0,0,0,0,SWP_NOMOVE + SWP_NOSIZE

	WMNCLBUTTONUP:
		invoke SetWindowPos,[hwnd],HWND_BOTTOM,0,0,0,0,SWP_NOMOVE + SWP_NOSIZE
		jmp >>.EXIT
		
	WMCLOSE:
		invoke EndDialog,[hwnd],0

	DEFPROC:
		xor eax,eax
		RET

	.EXIT

	xor eax,eax
	inc eax
	RET
ENDF

LVSubClass FRAME hwnd,uMsg,wParam,lParam
	LOCAL pt				:POINT
	LOCAL TextBuffer[256]	:B

	cmp D[uMsg],WM_DRAWITEM
	jne >>.WM_MEASUREITEM
		mov edi,[lParam]
		cmp D[wParam],999
		jne >>.DONE
			mov B[TextBuffer],0
			mov eax,[edi+DRAWITEMSTRUCT.itemState]
			test eax,ODS_SELECTED
			jz >
			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],000000FFh
			mov ecx,edi
			add ecx,DRAWITEMSTRUCT.rcItem
			invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ecx,[hLVBrush]
			jmp >.DRAWIT
			:
			invoke SetTextColor,[edi+DRAWITEMSTRUCT.hdc],00FF0000h
			invoke GetStockObject,WHITE_BRUSH
			mov ecx,edi
			add ecx,DRAWITEMSTRUCT.rcItem
			invoke FillRect,[edi+DRAWITEMSTRUCT.hdc],ecx,eax
			.DRAWIT
			invoke SetBkMode,[edi+DRAWITEMSTRUCT.hdc],TRANSPARENT
			
			mov eax,[edi+DRAWITEMSTRUCT.hwndItem]
			or eax,eax
			js >
				invoke SendMessage,[edi+DRAWITEMSTRUCT.hwndItem],CB_GETLBTEXT,\
					[edi+DRAWITEMSTRUCT.itemID],OFFSET TextBuffer
				jmp >.DRAWTEXT
			:
				invoke SendMessage,[edi+DRAWITEMSTRUCT.hwndItem],WM_GETTEXT,256,\
					OFFSET TextBuffer
			.DRAWTEXT
			mov eax,edi
			add eax,DRAWITEMSTRUCT.rcItem
			invoke DrawText,[edi+DRAWITEMSTRUCT.hdc],OFFSET TextBuffer,-1,\
				eax,DT_LEFT+DT_SINGLELINE+DT_VCENTER
			xor eax,eax
			inc eax
			ret

	.WM_MEASUREITEM
	cmp D[uMsg],WM_MEASUREITEM
	jne >>.DONE
		; Measurements for the combo box
		mov edi,[lParam]
		cmp D[wParam],999
		jne >.DONE
			;Find the DC for the combo box and get the text height
			invoke GetDlgItem,[hwnd],[wParam]
			mov ebx,eax ; EBX holds the Handle
			invoke GetDC,eax
			mov esi,eax ; ESI holds the DC
			; Just get the height for a single item
			; Owner drawn fixed only sends the message once
			; so it really makes no difference what text we use
			invoke GetTextExtentPoint32,esi,"Hello",5,OFFSET pt
			; Release the DC
			invoke ReleaseDC,ebx,esi
			mov eax,[pt.y]
			mov D[edi+MEASUREITEMSTRUCT.itemHeight],eax
			xor eax,eax
			inc eax
			ret

	.DONE

	invoke CallWindowProc,[pListViewFunc],[hwnd],[uMsg],[wParam],[lParam]
	RET
ENDF

SetUpListView FRAME 
	uses edi,esi
	LOCAL LVColumn		:LV_COLUMN
	LOCAL hdi			:HDITEM

	invoke ImageList_Create,16,16,ILC_MASK + ILC_COLOR24,1,10
	mov [hIml],eax
	invoke LoadIcon,[hInstance],10000
	push eax
	invoke ImageList_AddIcon,[hIml],eax
	pop eax
	invoke DestroyIcon,eax
	invoke LoadIcon,[hInstance],10001
	push eax
	invoke ImageList_AddIcon,[hIml],eax
	pop eax
	invoke DestroyIcon,eax

	invoke SendMessage,[hListView],LVM_SETIMAGELIST,LVSIL_SMALL,[hIml]

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],99
	mov D[LVColumn.pszText],OFFSET szColumn0
	mov D[LVColumn.cchTextMax],SIZEOF szColumn0
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,0,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],99
	mov D[LVColumn.pszText],OFFSET szColumn1
	mov D[LVColumn.cchTextMax],SIZEOF szColumn1
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,1,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],99
	mov D[LVColumn.pszText],OFFSET szColumn2
	mov D[LVColumn.cchTextMax],SIZEOF szColumn2
	mov D[LVColumn.iSubItem],1
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,2,ADDR LVColumn

	mov D[LVColumn.imask],LVCF_FMT + LVCF_TEXT + LVCF_WIDTH + LVCF_SUBITEM
	mov D[LVColumn.fmt],LVCFMT_LEFT
	mov D[LVColumn.lx],99
	mov D[LVColumn.pszText],OFFSET szColumn3
	mov D[LVColumn.cchTextMax],SIZEOF szColumn3
	mov D[LVColumn.iSubItem],2
	invoke SendMessage,[hListView],LVM_INSERTCOLUMN,3,ADDR LVColumn

	invoke SendMessage,[hListView],LVM_SETEXTENDEDLISTVIEWSTYLE,LVS_EX_FULLROWSELECT + LVS_EX_GRIDLINES,LVS_EX_GRIDLINES + LVS_EX_FULLROWSELECT 

	invoke ImageList_LoadImage,[hInstance],11000,16,0,08000FFh,IMAGE_BITMAP,LR_CREATEDIBSECTION
	invoke SendMessage,[hHeader],HDM_SETIMAGELIST,0,eax
	mov D[hdi._mask],HDI_FORMAT + HDI_IMAGE
	mov D[hdi.fmt],HDF_IMAGE + HDF_STRING + HDF_BITMAP_ON_RIGHT
	mov D[hdi.iImage],0

	invoke SendMessage,[hHeader],HDM_GETITEMCOUNT,0,0
	dec eax
	mov edi,eax
	:
		invoke SendMessage,[hHeader],HDM_SETITEM,edi,ADDR hdi
		dec edi
	jns <

	invoke SetWindowLong,[hListView],GWL_WNDPROC,OFFSET LVSubClass
	mov [pListViewFunc],eax

	ret
ENDF

LVAddItem FRAME Image,Col0,Col1,Col2,Col3
	LOCAL LVItem		:LV_ITEM
	LOCAL szItemID[16]	:B
	LOCAL ItemID		:D

	invoke SendMessage,[hListView],LVM_GETITEMCOUNT,0,0
	mov [ItemID],eax

	mov D[LVItem.imask],LVIF_PARAM + LVIF_TEXT + LVIF_IMAGE
	mov D[LVItem.iSubItem],0
	mov eax,[Col0]
	mov [LVItem.pszText],eax

	mov eax,[Image]
	mov [LVItem.iImage],eax
	mov D[LVItem.lParam],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	invoke SendMessage,[hListView],LVM_INSERTITEM,0,ADDR LVItem
	mov [ItemID],eax

	mov eax,[Col1]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],1
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR LVItem

	mov eax,[Col2]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],2
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR LVItem

	mov eax,[Col3]
	mov [LVItem.pszText],eax
	mov eax,[ItemID]
	mov [LVItem.iItem],eax
	mov D[LVItem.iSubItem],3
	mov D[LVItem.imask],LVIF_TEXT
	invoke SendMessage,[hListView],LVM_SETITEM,0,ADDR LVItem

	mov eax,[ItemID]
	ret
ENDF

ShowLVMenu FRAME hWin
	LOCAL hPopMenu  :D
	LOCAL MCommand	:D
	LOCAL lvht		:LVHITTESTINFO
	LOCAL lvi		:LV_ITEM
	LOCAL pClipData	:D

	jmp >
		szCopyM: db "Copy",0
		szPasteM: db "Paste",0
	:

	invoke GetCursorPos, ADDR lvht.pt
	invoke ScreenToClient,[hWin],ADDR lvht.pt
	invoke ChildWindowFromPoint, [hWin], [lvht.pt.x], [lvht.pt.y]
	cmp eax,[hListView]
	jnz >>.DONE
		invoke GetCursorPos, ADDR lvht.pt
		invoke CreatePopupMenu
		mov [hPopMenu], eax
		invoke AppendMenu, [hPopMenu], MF_STRING, 100, OFFSET szCopyM
		invoke AppendMenu, [hPopMenu], MF_STRING, 101, OFFSET szPasteM
		invoke TrackPopupMenu, [hPopMenu], TPM_LEFTALIGN + TPM_RETURNCMD,\
				[lvht.pt.x], [lvht.pt.y], NULL, [hListView], NULL
		mov [MCommand],eax
		invoke ScreenToClient, [hListView], ADDR lvht.pt
		mov D[lvht.flags],LVHT_ONITEM
		invoke SendMessage, [hListView], LVM_SUBITEMHITTEST, 0, ADDR lvht
		mov eax,[lvht.iItem]
		or eax,eax
		js >>.DONE
		cmp D[MCommand],100
		jnz >>L1
			mov [lvi.iItem], eax
			invoke OpenClipboard, [hWin]
			or eax,eax
			jz >>.DONE
				invoke EmptyClipboard
				invoke GlobalAlloc,GMEM_MOVEABLE + GMEM_ZEROINIT,4096
				mov [hClipData],eax
				invoke GlobalLock,[hClipData]
				mov [lvi.pszText], eax
				mov eax,[lvht.iSubItem]
				mov [lvi.iSubItem], eax
				mov D[lvi.imask], LVIF_TEXT
				mov D[lvi.cchTextMax], 4095
				invoke SendMessage, [hListView], LVM_GETITEM, 0, ADDR lvi
				invoke GlobalUnlock,[hClipData]
				invoke SetClipboardData, CF_TEXT, [hClipData]
				invoke CloseClipboard
				jmp >>.DONE

		L1:
		cmp D[MCommand],101
		jnz >>.DONE
			mov [lvi.iItem], eax
			mov eax,[lvht.iSubItem]
			mov [lvi.iSubItem], eax
			mov D[lvi.imask], LVIF_TEXT
			invoke IsClipboardFormatAvailable, CF_TEXT
			or eax,eax
			jz >P2
				invoke OpenClipboard, [hWin]
				or eax,eax
				jz >P2
					invoke GetClipboardData, CF_TEXT
					or eax,eax
					jz >P1
						push eax
						invoke GlobalLock,eax
						mov [lvi.pszText], eax
						invoke SendMessage, [hListView], LVM_SETITEM, 0, ADDR lvi
						pop eax
						invoke GlobalUnlock,eax
					P1:
					invoke CloseClipboard
			P2:
			invoke DestroyMenu, [hPopMenu]

	.DONE
	ret

ENDF

LVSortProc FRAME lParam1,lParam2,lParamSort
	uses ebx,edi,esi
	LOCAL	ItemData1		:LV_ITEM
	LOCAL	ItemData2		:LV_ITEM
	LOCAL	Tbuff1[256]		:B
	LOCAL	Tbuff2[256]		:B

	; lParamSort pointer to LVSORT structure
	mov edi,[lParamSort]
	mov ebx,[edi+LVSORT.column]
	mov esi,[edi+LVSORT.handle]

	mov eax,[lParam1]
	mov [ItemData1.iItem],eax
	mov [ItemData1.iSubItem],ebx
	mov D[ItemData1.imask],LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,Tbuff1
	mov [ItemData1.pszText],eax
	mov D[ItemData1.cchTextMax],255
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData1

	mov eax,[lParam2]
	mov [ItemData2.iItem],eax
	mov [ItemData2.iSubItem],ebx
	mov D[ItemData2.imask],LVIF_TEXT + LVIF_PARAM + LVIF_IMAGE
	lea eax,Tbuff2
	mov [ItemData2.pszText],eax
	mov D[ItemData2.cchTextMax],255
	invoke SendMessage,esi,LVM_GETITEM,0,OFFSET ItemData2

	cmp D[edi+LVSORT.type],1
	mov edi,[edi+LVSORT.direction]
	jb >P1
	ja >I1
	
	; String sort
	invoke lstrcmpi,OFFSET Tbuff1,OFFSET Tbuff2
	or edi,edi
	jz >
		neg eax
	:
	ret

	; lParam sort
	P1:
	mov eax,[ItemData2.lParam]
	mov ecx,[ItemData1.lParam]
	cmp ecx,eax
	jae >
		mov eax,-1
		jmp >P2
	:
	jne >
		mov eax,0
		jmp >P2
	:
		mov eax,1
	P2:
	or edi,edi
	jz >
		neg eax
	:
	ret

	; Image sort
	I1:
	mov eax,[ItemData2.iImage]
	mov ecx,[ItemData1.iImage]
	cmp ecx,eax
	jae >
		mov eax,-1
		jmp >I2
	:
	jne >
		mov eax,0
		jmp >I2
	:
		mov eax,1
	I2:
	or edi,edi
	jz >
		neg eax
	:
	ret

ENDF

LVEditBox FRAME hwnd,uMsg,wParam,lParam
	uses ebx
	LOCAL lvi		:LV_ITEM
	LOCAL systime	:SYSTEMTIME

	cmp D[uMsg],WM_KILLFOCUS
	jne >>L1
		invoke GetWindowLong,[hwnd],GWL_USERDATA
		mov ebx,eax
		cmp D[ebx+CBDATA.fType],0
		jne >T1
			invoke SendMessage,[hwnd],CB_GETCURSEL,0,0
			or eax,eax
			js >>
				invoke SendMessage,[hwnd],CB_GETLBTEXT,eax,OFFSET cbstring
				
				mov eax,[ebx+CBDATA.iItem]
				mov [lvi.iItem],eax
				mov eax,[ebx+CBDATA.iSubitem]
				mov [lvi.iSubItem],eax
				mov D[lvi.imask],LVIF_TEXT
				mov D[lvi.pszText],OFFSET cbstring
				invoke SendMessage,[ebx+CBDATA.hParent],LVM_SETITEMTEXT,[ebx+CBDATA.iItem],OFFSET lvi
			:
			invoke SendMessage,[hwnd],WM_CLOSE,0,0
			jmp >>L1
		T1:
		cmp D[ebx+CBDATA.fType],1
		jne >T2
			invoke SendMessage,[hwnd],DTM_GETMONTHCAL,0,0
			cmp eax,[wParam]
			je >
				invoke SendMessage,[hwnd],DTM_GETSYSTEMTIME,0,OFFSET systime
				movzx eax,W[systime.wDay]
				invoke SendMessage,eax,WM_CLOSE,0,0
				invoke SendMessage,[hwnd],WM_CLOSE,0,0
			:
			jmp >>L1
		T2:
	L1:
	invoke GetWindowLong,[hwnd],GWL_USERDATA
	invoke CallWindowProc,[eax+CBDATA.pOldProc],[hwnd],[uMsg],[wParam],[lParam]
	ret
ENDF
